"use strict";
var optimization = require('./optimization');
var decorators = require('./optimization/decorators');
var treeshake = require('./optimization/treeshake');
var helpers = require('./util/helpers');
var file_cache_1 = require('./util/file-cache');
describe('optimization task', function () {
    describe('doOptimizations', function () {
        it('should not run optimizations unless flags are set', function () {
            // arrange
            var fileCache = new file_cache_1.FileCache();
            fileCache.set('somePath', { path: 'somePath', content: 'someContent' });
            var context = {
                fileCache: fileCache
            };
            spyOn(helpers, helpers.getBooleanPropertyValue.name).and.returnValue(false);
            spyOn(decorators, decorators.purgeDecorators.name);
            spyOn(treeshake, treeshake.calculateUnusedComponents.name);
            // act
            var result = optimization.doOptimizations(context, new Map());
            // assert
            expect(result).toBeTruthy();
            expect(decorators.purgeDecorators).not.toHaveBeenCalled();
            expect(treeshake.calculateUnusedComponents).not.toHaveBeenCalled();
        });
    });
});
