import { Renderer2, ElementRef, EventEmitter, AfterViewInit, OnDestroy, NgZone } from '@angular/core';
import { DomController, Platform } from 'ionic-angular';
import { SuperTabsConfig } from '../super-tabs/super-tabs';
export declare class SuperTabsContainer implements AfterViewInit, OnDestroy {
    private el;
    private rnd;
    private plt;
    private domCtrl;
    private ngZone;
    config: SuperTabsConfig;
    tabsCount: number;
    selectedTabIndex: number;
    tabSelect: EventEmitter<{
        index: number;
        changed: boolean;
    }>;
    onDrag: EventEmitter<TouchEvent>;
    containerPosition: number;
    container: ElementRef;
    tabWidth: number;
    containerWidth: number;
    private minPosX;
    private maxPosX;
    private gesture;
    private globalSwipeEnabled;
    private swipeEnabledPerTab;
    constructor(el: ElementRef, rnd: Renderer2, plt: Platform, domCtrl: DomController, ngZone: NgZone);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    enableTabsSwipe(enable: boolean): void;
    enableTabSwipe(tabIndex: number, enable: boolean): void;
    refreshDimensions(): void;
    getNativeElement(): HTMLElement;
    private init();
    private setSelectedTab(index);
    private calculateContainerWidth();
    setHeight(height: number): void;
    private setContainerWidth();
    slideTo(index: number, animate?: boolean): void;
    private moveContainer(animate?, positionX?, callback?);
    private refreshMinMax();
}
