import { NgModule } from '@angular/core';
import { IonicApp, IonicModule } from 'ionic-angular';
import { StatusBar, Splashscreen } from 'ionic-native';


import { MyApp } from './app.component';
import { Registro } from '../pages/registro/registro';
import { Home } from '../pages/home/home';
import { Tabs } from '../pages/tabs/tabs';
import { Aprendiz } from '../pages/aprendiz/aprendiz';
import { ListaDetalle } from '../pages/lista-detalle/lista-detalle';
import { AprendizFoto } from '../pages/aprendiz-foto/aprendiz-foto';
import { Inasistencia } from '../pages/inasistencia/inasistencia';
import { Desempeno } from '../pages/desempeno/desempeno';
import { DesempenoActividad } from '../pages/desempeno-actividad/desempeno-actividad';
import { DesempenoCalifica } from '../pages/desempeno-califica/desempeno-califica';
import { Chat } from '../pages/chat/chat';
import { AsociaFicha } from '../pages/asocia-ficha/asocia-ficha';




import { VarsGlobales } from '../providers/vars-globales';
import { CloudSettings, CloudModule } from '@ionic/cloud-angular';

const cloudSettings: CloudSettings = {
  'core': {
    'app_id': '46480c20'
  }
};

@NgModule({
  declarations: [
    MyApp,
    Registro,
    Home,
    Tabs,
    AsociaFicha,
    Aprendiz,
    ListaDetalle,
    AprendizFoto,
    Inasistencia,
    Desempeno,
    DesempenoActividad,
    DesempenoCalifica,
    Chat
  ],
  imports: [
    IonicModule.forRoot(MyApp),
     CloudModule.forRoot(cloudSettings)
  ],
  bootstrap: [IonicApp],
  entryComponents: [
    MyApp,
    Registro,
    Home,
    Tabs,
    AsociaFicha,
    Aprendiz,
    ListaDetalle,
    AprendizFoto,
    Inasistencia,
    Desempeno,
    DesempenoActividad,
    DesempenoCalifica,
    Chat
  ],
  providers: [
  VarsGlobales,
  StatusBar,
    Splashscreen
  ]
})
export class AppModule {}
