import { Component } from '@angular/core';
import { NavController} from 'ionic-angular'; //Permite la navegabilidad
import { VarsGlobales } from '../../providers/vars-globales'; //Toma información almacenadas emn las variables globales
import { SigaService } from '../../providers/siga-service'; //Agrega o toma la información de la base de datos
import { ListaDetalle } from '../lista-detalle/lista-detalle'; //Importa la página que llamaremos por push
import { Chat } from '../chat/chat'; //Importa la página que llamaremos por push
//import { Tabs } from '../tabs/tabs';


declare var cordova: any;

/*
  Generated class for the Aprendiz page.

  See http://ionicframework.com/docs/v2/components/#navigation for more info on
  Ionic pages and navigation.
*/

//Agregamos los proovedores para activar las variables globales en todas las páginas

@Component({
  selector: 'page-aprendiz',
  templateUrl: 'aprendiz.html',
  providers: [SigaService]
})




export class Aprendiz {

  //Declaración de variables 

  recFicha;
	ficha; //Informacion sobre la ficha
	nomUsuario; //Almacena la informacion del Instructor
  nomPrograma; //Almacenal la información del programa de formación
  bddAprendices; //Almacena la base de datos de los aprendices
  aprendiz; //Almacena el id del aprendiz
  photo :boolean = false;

  
  

  constructor(public navCtrl: NavController, public varsGlobales: VarsGlobales, 
                public servicios: SigaService) {

    //Almacena en las variables locales lo almacenado en las Globales
    this.ficha = varsGlobales.getFicha();
    this.nomUsuario = varsGlobales.getNomUsuario();
    this.nomPrograma = varsGlobales.getNomPrograma();

    //Trae la infomacion de la base de datos de los aprendices 
     this.servicios.getBddAprendices(this.ficha)
        .then(
          data => {
            console.log(data);
            this.bddAprendices = data;
            varsGlobales.setBddAprendices(data);
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )


  }

  public get envioFicha() : string {
    return this.recFicha;
  }

  public set reciboFicha(v : string) {
    this.recFicha = v;
  }


  ionViewDidLoad() {
    console.log('ionViewDidLoad AprendizPage');

  }


//Agrega la información en la base de datos de los aprendices
editAprendices(index){
     this.aprendiz = this.bddAprendices[index].apId;  //S
    this.varsGlobales.setDocAprendiz(this.aprendiz);
    this.navCtrl.push(ListaDetalle);
}

openChat(){
   this.navCtrl.push(Chat);
}

}
