import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';
import { VarsGlobales } from '../../providers/vars-globales';
import { SigaService } from '../../providers/siga-service';
import { AlertController } from 'ionic-angular';


/*
  Generated class for the Grupo page.

  See http://ionicframework.com/docs/v2/components/#navigation for more info on
  Ionic pages and navigation.
*/
@Component({
  selector: 'page-asocia-ficha',
  templateUrl: 'asocia-ficha.html',
  providers: [SigaService]
})

export class AsociaFicha {

  idUsuario;
  idFicha;
  nomUsuario;
  noFicha;
  nomPrograma
  isenabled:boolean=false;
  

constructor(public navCtrl: NavController, public varsGlobales: VarsGlobales, 
                public servicios: SigaService, public alertCtrl:AlertController) {
        //Almacena en las variables locales la información de las variabes Globales

        this.nomUsuario=varsGlobales.getNomUsuario();
        this.idUsuario=varsGlobales.getDocUsuario();
  }


  ////////////////////////////////
  public get Usuario() : string {
    return this.idUsuario;
  }


  public get Ficha() : string {
    return this.idFicha;
  }



  ////////////////////////////////



  //Busca en la base de datos de la Ficha el nombre del programa de formación
  buscar(){

    
    this.servicios.getBddFicha(this.noFicha)
        .then(
          data => {

if(data["error"] == "ok"){
  



                let alert = this.alertCtrl.create(
                {
                  title:"Aviso",
                  subTitle: "La ficha no existe",
                  buttons: ["ok"]
                }
              );
              alert.present();
              this.noFicha =  ' ';
            }
else{



            console.log("este es data: "+data);
            this.idFicha = data;
            this.nomPrograma = data[0].fiNombre;
            this.isenabled=true;
  }          
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
/*
   
    this.servicios.getBddFicha(this.noFicha)
        .then(
          data => {
            console.log(data);
            if(data["response"] == "ok"){
              console.log("Valor data: "+data)
              if(data == null || parseInt(data) == 0){
                let alert = this.alertCtrl.create(
                {
                  title:"Aviso",
                  subTitle: "Ficha no existe",
                  buttons: ["ok"]
                }
                );
                alert.present();
              }
            }
            this.idFicha = data;
            this.nomPrograma = data[0].fiNombre;
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
*/
  
   

  }

  
  /*
    Asocia la ficha al instructor, creando un arreglo con la información
    a guardar con los datos de Ficha y Usuario
  */
  
  guardar(){
    var datos = {};
    datos["afIdFicha"] = this.noFicha;
    datos["afIdUsuario"] = this.idUsuario;
    this.servicios.setAsociaFicha(datos)
        .then(
          data => {
            console.log(data);
            if(data["response"] == "ok"){
                let alert = this.alertCtrl.create(
                {
                  title:"Aviso",
                  subTitle: "Registro añadido",
                  buttons: ["ok"]
                }
              );
              alert.present();
            }
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
        console.log("En espera");
        //this.navCtrl.remove(2);
   }
}

