import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';
import * as io from 'socket.io-client';

import { VarsGlobales } from '../../providers/vars-globales'; //Toma información almacenadas emn las variables globales



/*
  Generated class for the Chat page.

  See http://ionicframework.com/docs/v2/components/#navigation for more info on
  Ionic pages and navigation.
*/
@Component({
  selector: 'page-chat',
  templateUrl: 'chat.html'
})

export class Chat {
	socket:any
  chat_input:string;
  chats = [];
  nomUsuario;
  myUsuario;
  isenabled: boolean = false;
  myIp;
  subsNombre = [];

  constructor(public navCtrl: NavController, public varsGlobales: VarsGlobales) {
    /*
      Crea el Socket para la interacción en tiempo real en el chat
      utilizando el puerto 3000
    */
    this.myIp = varsGlobales.getIp();
    
    this.nomUsuario = varsGlobales.getNomChat();
    this.myUsuario = this.nomUsuario;

    console.log("Nombre Usuario: "+ this.nomUsuario);

  	this.socket = io(this.myIp+':3000');
  	 this.socket.on('message', (msg) => {
      console.log("message", msg);
      this.chats.push(msg);

      this.subsNombre = msg.split(" ");
 

    });
  }

  ionViewDidLoad() {
    console.log('ionViewDidLoad Chat');
  }
  /*
    Envio del mensaje
  */
  send(msg, msg2) {
        //if(msg != ''){
            this.socket.emit('message', msg+" "+msg2);
        //}
        this.chat_input = '';
    }



}
