import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';

import { VarsGlobales } from '../../providers/vars-globales';
import { SigaService } from '../../providers/siga-service';

import { AlertController } from 'ionic-angular';

/*
  Generated class for the DesempenoActividad page.

  See http://ionicframework.com/docs/v2/components/#navigation for more info on
  Ionic pages and navigation.
*/
@Component({
  selector: 'page-desempeno-actividad',
  templateUrl: 'desempeno-actividad.html',
  providers: [SigaService]
})
export class DesempenoActividad {
  //Variables de la clase
  myDateI: String = new Date().toISOString().substring(0, 10);
  myDateF = this.myDateI;
  noFicha;
  nomPrograma;
  tituloAct;
  //guiaAct;
  evidenciaAct;
  bddAprendices;
  prb;
  idUsuario;
  i=0;
  incremento;
  public respuesta: string;
  

  constructor(public navCtrl: NavController, public varsGlobales: VarsGlobales, 
  							public servicios: SigaService, public alertCtrl:AlertController) {

      /*Almacenamieto en las variables locales la información contenida
       en las variables globales*/

      this.noFicha = varsGlobales.getFicha();
      this.nomPrograma = varsGlobales.getNomPrograma();
      this.bddAprendices = varsGlobales.getBddAprendices();
      this.idUsuario = varsGlobales.getDocUsuario();

  }

    ionViewDidLoad() {
    console.log('ionViewDidLoad DesempenoActividad');
  }

  /*
    Almacenamiento en la base de datos de Desempeño, realizando el
     AutoIncremento para la actividad
  */
  autoIncremento(data){
    this.i=0;
    var datos2 = {};
    this.incremento = parseInt(data)-1;
    for(this.prb in this.bddAprendices){
        datos2["deIdAprendiz"] = this.prb=this.bddAprendices[this.i].apId;
        datos2["deIdUsuario"] = this.idUsuario;
        datos2["deIdActividad"] = this.incremento; 
        datos2["deIdFicha"] = this.noFicha;
        console.log("Prb: "+this.prb);
        this.i++;

      this.servicios.setBddDesempeno(datos2)
        .then(
          data => {
            console.log(data);
            if(data["response"] == "ok"){
                let alert = this.alertCtrl.create(
                {
                  title:"Aviso",
                  subTitle: "Registro añadido",
                  buttons: ["ok"]
                }
              );
              alert.present();
            }
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
    }
  }

  /*
    Almacenamiento en la base de datos de actividad, realizando el
     AutoIncremento para la actividad
  */

  guardar(){
    var datos = {};
    datos["acTitulo"] = this.tituloAct;
    datos["acGuia"] = " "; //this.guiaAct;
    datos["acEvidencia"] = this.evidenciaAct;
    datos["acFechaInicio"] = this.myDateI;
    datos["acFechaFin"] = this.myDateF;
    datos["acUsuarioD"] = this.idUsuario;
    datos["acFichaD"] = this.noFicha;
    console.log(datos);
    this.servicios.setBddActividad(datos)
        .then(
          data => {
            console.log("Este es data: "+data);
            this.autoIncremento(data[0].AUTO_INCREMENT)            
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
        this.navCtrl.remove(1);
   }

}
