import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';


import { VarsGlobales } from '../../providers/vars-globales';
import { SigaService } from '../../providers/siga-service';
import { DesempenoActividad } from '../desempeno-actividad/desempeno-actividad';
import { DesempenoCalifica } from '../desempeno-califica/desempeno-califica';
import { Chat } from '../chat/chat'; //Importa la página que llamaremos por push
//import { Tabs } from '../tabs/tabs';
/*
  Generated class for the Desempeno page.

  See http://ionicframework.com/docs/v2/components/#navigation for more info on
  Ionic pages and navigation.
*/
@Component({
  selector: 'page-desempeno',
  templateUrl: 'desempeno.html',
  providers: [SigaService]
})

export class Desempeno {

  //Creación de las variables
  bddAprendFecha;
  bddAprendices;
  bddActividad;
  noFicha;
  idUsuario;
  nomPrograma;
  //Creación de la variable Date solo pidiento el año mes y dia sin tener en cuenta la hora
  myDate: String = new Date().toISOString().substring(0, 10);

  constructor(public navCtrl: NavController, public varsGlobales: VarsGlobales, 
  							public servicios: SigaService) {
      
      //Asignación a las variables locales la información de las variables globales
      this.bddAprendices = varsGlobales.getBddAprendices();
      this.noFicha = varsGlobales.getFicha();
      this.idUsuario = varsGlobales.getDocUsuario();
      this.nomPrograma = varsGlobales.getNomPrograma();

      this.desempenoUA();
  }

  ionViewDidLoad() {
    console.log('ionViewDidLoad Desempeno');
  }

  //Consulta la información de la base de datos verificando si existen actividades 
  desempenoUA(){
    this.servicios.getBddActividadAct(this.myDate, this.idUsuario, this.noFicha)
        .then(
          data => {
            console.log(data);
            this.bddActividad = data;
          }
        )
        .catch(
          error => {
            console.log("error"+error);
          }
        )
  }

  //Realiza la llamada a la página Desempeño
  llamaDesempeoAct(){
    this.navCtrl.push(DesempenoActividad);
  }

  //Almacena la información del aprendiz seleccionado y llama a la página de calificación
  editAprendiz(index){
    this.varsGlobales.setDocAprendiz(this.bddAprendices[index].apId);
    this.navCtrl.push(DesempenoCalifica, {
      aprendiz:this.bddAprendices[index].apNombre+" "+this.bddAprendices[index].apApellido
      }
    );
  }

  openChat(){
   this.navCtrl.push(Chat);
}

}
