//import { Prueba } from '../../app/prueba'

import { Component } from '@angular/core';
import { NavController} from 'ionic-angular';
import { AsociaFicha } from '../asocia-ficha/asocia-ficha';
import { Tabs } from '../tabs/tabs';
import { VarsGlobales } from '../../providers/vars-globales';
import { SigaService } from '../../providers/siga-service';
import { AlertController } from 'ionic-angular';

/*
  Generated class for the Home page.

  See http://ionicframework.com/docs/v2/components/#navigation for more info on
  Ionic pages and navigation.
*/
@Component({
  selector: 'page-home',
  templateUrl: 'home.html',
  providers: [SigaService]
})

export class Home {
  //Declaración de las variables locales de la clase
  asociaFicha;
  noFicha;
  nomPrograma;
  docUsuario;
  isenabled:boolean=false;
  //doc = '94229067';
  doc;
  nomUsuario;
  ficha;

  constructor(public navCtrl: NavController, public varsGlobales: VarsGlobales, 
  							public servicios: SigaService, public alertCtrl:AlertController) {

    this.doc = varsGlobales.getDocUsuario();

   
  }

  //Al ingresar al botón de asociar ficha se realiza el llamdo
  llamaAsociaFicha() {
    this.navCtrl.push(AsociaFicha);
  }

  //En el momento de elegir la ficha, ingresa al sistema de navegación por pestañas
  editFicha(index){
    this.ficha = this.asociaFicha[index].afIdFicha;
    this.varsGlobales.setFicha(this.ficha);
    this.varsGlobales.setNomPrograma(this.asociaFicha[index].fiNombre);
    this.navCtrl.push(Tabs);
  }

  ionViewDidLoad() {
    console.log('ionViewDidLoad HomePage');
    
  }


  ionViewDidEnter(){
     //Obtiene de la base de datos las fichas donde el instructor esta asociado
    this.servicios.getBddAsociaFicha(this.doc)
      .then(
        data => {
            console.log(data);
            this.asociaFicha = data;
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
        /*
          Obtiene de la base de datos de Usuario el documento y 
          el nombre del usuario que ingresó al sistema
        */
        this.servicios.getBddUsuario(this.doc)
        .then(
          data => {
            console.log(data);
            this.docUsuario = data;
            this.nomUsuario = data[0].usNombre + ' '+data[0].usApellido;
            this.varsGlobales.setNomUsuario(this.nomUsuario);
            this.varsGlobales.setNomChat(data[0].usNombre);
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
    
  }


  //Busca en la base de datos de la Ficha el nombre del programa de formación
  buscar(){

    
    this.servicios.getBddFicha(this.noFicha)
        .then(
          data => {

if(data["error"] == "ok"){
  



                let alert = this.alertCtrl.create(
                {
                  title:"Aviso",
                  subTitle: "La ficha no existe",
                  buttons: ["ok"]
                }
              );
              alert.present();
              this.noFicha =  ' ';
            }
else{



            console.log("este es data: "+data);
            this.noFicha = data;
            this.nomPrograma = data[0].fiNombre;
            this.isenabled=true;
            this.showConfirm();
  }          
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )

}

guardar(){
    var datos = {};
    datos["afIdUsuario"] = this.doc;
    datos["afIdFicha"] = this.noFicha[0].fiId;
    this.servicios.setAsociaFicha(datos)
        .then(
          data => {
            console.log(data);
            if(data["response"] == "ok"){
                let alert = this.alertCtrl.create(
                {
                  title:"Aviso",
                  subTitle: "Registro añadido",
                  buttons: ["ok"]
                }
              );
              alert.present();
            }
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
        console.log("En espera");
        //this.navCtrl.remove(2);
        this.navCtrl.insert(1, Home);
this.navCtrl.pop();

   }

   refreshPage()
  {this.ionViewDidEnter();
}

showConfirm() {
    let confirm = this.alertCtrl.create({
      title: 'Desea Asignar la ficha: '+this.noFicha[0].fiId+'?',
      message: this.nomPrograma,
      buttons: [
        {
          text: 'No Asociar',
          handler: () => {
            console.log('Disagree clicked');
            
          }
        },
        {
          text: 'Asociar',
          handler: () => {
            console.log('Agree clicked');
            this.guardar();
          }
        }
      ]
    });
    confirm.present();
  }

}
