import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';

import { VarsGlobales } from '../../providers/vars-globales';
import { SigaService } from '../../providers/siga-service';

import { Chat } from '../chat/chat'; //Importa la página que llamaremos por push


import { AlertController } from 'ionic-angular';

/*
  Generated class for the Inasistencia page.

  See http://ionicframework.com/docs/v2/components/#navigation for more info on
  Ionic pages and navigation.
*/
@Component({
  selector: 'page-inasistencia',
  templateUrl: 'inasistencia.html',
  providers: [SigaService]
})
export class Inasistencia {

  //Variables Locales de la clase
  bddAprendFecha;
  bddAprendices;
  miAprendiz;
  noFicha;
  idUsuario;
  myDate: String = new Date().toISOString().substring(0, 10);

  isenabled:boolean=false;
  barColor: string;
  activa;
  nomPrograma;
  gesture;
  array_inasist:number []=[];
  

  constructor(public navCtrl: NavController, public varsGlobales: VarsGlobales, 
  							public servicios: SigaService, public alertCtrl:AlertController) {
      
      //Almacenamos la información en las variables Locales de las variables Globales
      this.bddAprendices = varsGlobales.getBddAprendices();
      this.noFicha = varsGlobales.getFicha();
      this.idUsuario = varsGlobales.getDocUsuario();
      this.nomPrograma = varsGlobales.getNomPrograma();
      this.verificaInasistencia();
  }

  ionViewDidLoad() {
    console.log('ionViewDidLoad Inasistencia');
  }

  //Agrega la información del motivo de la inasistencia

  motivo() {
    console.log("Mantuvo presionado");
  let alert = this.alertCtrl.create({
    title: 'Motivo',
    inputs: [
      {
        name: 'username',
        placeholder: 'Username'
      },
      {
        name: 'password',
        placeholder: 'Password',
        type: 'password'
      }
    ],
    buttons: [
      {
        text: 'Cancel',
        role: 'cancel',
        handler: data => {
          console.log('Cancel clicked');
        }
      },
      {
        text: 'Login',
        handler: data => {
        }
      }
    ]
  });
  alert.present();
}

  //Verifica si aplica inasistencia en la base de datos
  verificaInasistencia(){
    this.servicios.getBddInasistenciaFecha(this.myDate, this.noFicha, this.idUsuario)
        .then(
          data => {
            console.log("esto es data: "+data);
            this.bddAprendFecha = data;
            this.agregaMarca(this.bddAprendFecha);
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
  }


  
agregaMarca(aprendFecha){
    for(var i in this.bddAprendices){
        this.array_inasist[i] = 0;  
        console.log("Agrega marca Asigno a 0 pos"+i);
      for(var x in this.bddAprendFecha){
        if(this.bddAprendices[i].apId == aprendFecha[x].inIdAprendiz){
           this.array_inasist[i] = 1;  
           console.log("Agrega Marca Asigno a 1 pos:"+i);    
           break;        
        }
        
      }
    }
  }


  //Registra la inasistencia en la base de datos
  editInasistencia(index){
    var datos = {};
    datos["inIdAprendiz"] = this.bddAprendices[index].apId;
    datos["inIdUsuario"] = this.idUsuario;
    datos["inFecha"] = this.myDate;
    if(this.array_inasist[index] == 1){ //Hacer un delete
      //Elimina Inasistencia   
       this.servicios.setEliminaAsistencia(datos)
        .then(
          data => {
            this.array_inasist[index] = 0;  
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
    }
    else{
      datos["inMotivo"] = "";
      datos["inFicha"] = this.noFicha;
       //Agrega Inasistencia   
       this.servicios.setInasistencia(datos)
        .then(
          data => {
            this.array_inasist[index] = 1;   //Hacer un Insert
          }
        )
        .catch(
          error => {
            console.log(error);
          }
        )
    }
    



  }

  openChat(){
   this.navCtrl.push(Chat);
}

 onGesture(text){
   console.log(text);
   this.gesture = text;
 }

//Almacenamos la información en la base de dato justo antes de salir
 ionViewWillLeave(){

         }          

 camFecha(){
   console.log("Cambio de fecha");
   this.array_inasist=[0];
   this.verificaInasistencia();

   /////OJO Y DEBE ACTUALIZAR LA BASE DE DATOS CON LOS CAMBIOS DE LA FECHA ANTERIOR

 }


}
