import { Injectable } from '@angular/core';
import { Http } from '@angular/http';
import 'rxjs/add/operator/map';
import { VarsGlobales } from './vars-globales'; //Toma información almacenadas emn las variables globales

/*
  Generated class for the SigaService provider.

  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
  for more info on providers and Angular 2 DI.
*/
@Injectable()
export class SigaService {

  //myIp = "http://127.0.0.1";
  myIp = "http://192.168.1.2";
  //myIp = "http://192.168.0.19";
  
  
  myPort = ":80/siga";
  myHttp = this.myIp+this.myPort;

  constructor(public http: Http, public varsGlobales: VarsGlobales) {
    varsGlobales.setIp(this.myIp);
    console.log('Hello SigaService Provider');
  }

  //Recupera todos los datos  //CARGANDO LOS DATOS
  //TypeScript: promise
  //Los datos que recupero lleguen al documento cuando esten disponibles y no antes
  //this.http Proveedor de servicios que se ocupa de la conexión de internet
  //get llama a la Url donde se encuentra los datos
  //.map Mapea el resultado (objeto json)
  //.subscribe Envia los datos a los que estan subscritos

  getFoto(aprendiz){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/getfoto/"+aprendiz) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
               
            console.log("ERROR grave" +err);
          }
        )
      }
    );
  }

 setFoto(data){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/setfoto/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }
  
  getRegistro(id, contrasena){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/registro/"+id+"/"+contrasena) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
               
            console.log("ERROR grave" +err);
          }
        )
      }
    );
  }

  getBddAsociaFicha(id){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/asociaficha/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }


  


  getBddUsuario(id){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/usuario/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }

  getBddFicha(id){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/ficha/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
               console.log(data);
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }


  getBddAprendices(id){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/aprendices/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }  

 


  getBddAprendiz(id){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/aprendiz/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }

  getBddInasistenciaG(id){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/inasistenciag/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  

  getBddInasistenciaU(id, id2){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/inasistenciau/"+id+"/"+id2) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  getBddInasistenciaFecha(fecha, ficha, usuario){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/inasistenciafecha/"+fecha+"/"+ficha+"/"+usuario) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }  

  setInasistencia(data){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/inasistencia", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }  

  setEliminaAsistencia(data){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/eliminasistencia", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }

  getBddDesempenoG(id){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/desempenog/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  } 

  getBddDesempenoGA(id){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/desempenoga/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  } 

  getBddDesempenoGD(id){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/desempenogd/"+id) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  } 



  getBddDesempenoU(id, id2){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/desempenou/"+id+"/"+id2) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  getBddDesempenoUA(id, id2){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/desempenoua/"+id+"/"+id2) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  getBddDesempenoUD(id, id2){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/desempenoud/"+id+"/"+id2) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }


  getBddActividadAct(fecha, usuario, ficha){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/actividadact/"+fecha+"/"+usuario+"/"+ficha) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }  


   getBddCalifica(aprendiz, ficha, usuario){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/calificacion/"+aprendiz+"/"+ficha+"/"+usuario) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  getBddMuestraAccion(aprendiz, ficha, usuario){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.get(this.myHttp+"/muestraacc/"+aprendiz+"/"+ficha+"/"+usuario) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  setBddCalificaAp(data){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/calificaap/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }


  setBddCalificaNAp(data){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/calificanap/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  setBddCalificaAcc(data){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/calificaacc/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }



  setBddAccionMejora(data){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/accionmejora/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }

  setBddDesempenoAM(data){
    console.log("Envio BDD: "+data);
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/accionmejoraid/",data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }  

  setBddAccionAp(data){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/calificaaccion/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }  


  setBddActividad(data){
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/actividad/",data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }  

  setBddDesempeno(data){
    console.log("Envio BDD: "+data);
   return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/desempeno/",data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    ); 
  }  

 



  setAsociaFicha(data){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/asociaf/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }

  setActualizaDatos(data){
    return new Promise(
      resolve=>{  //QAue va a ocurrir cuando se resuelva
        this.http.post(this.myHttp+"/actualiza/", data) 
        .map(res=>res.json())
        .subscribe(
          data =>{
              //this.variable = data;  //Puedo hacer comparaciones
              resolve(data);
          },
          err=>{
            console.log(err);
          }
        )
      }
    );
  }





////////////////////////////////////////////////////////////////////////

  getAll(){
  	return new Promise(
  		resolve=>{  //QAue va a ocurrir cuando se resuelva
  			this.http.get(this.myHttp+"/all") 
  			.map(res=>res.json())
  			.subscribe(
  				data =>{
  						//this.variable = data;  //Puedo hacer comparaciones
  						resolve(data);
  				},
  				err=>{
  					console.log(err);
  				}
  			)
  		}
  	);
  }

  addVez(id){
  	return new Promise(
  		resolve=>{  //QAue va a ocurrir cuando se resuelva
  			this.http.get(this.myHttp+"/one/"+id) 
  			.map(res=>res.json())
  			.subscribe(
  				data =>{
  						//this.variable = data;  //Puedo hacer comparaciones
  						resolve(data);
  				},
  				err=>{
  					console.log(err);
  				}
  			)
  		}
  	);
  }

  add(data){
  	return new Promise(
  		resolve=>{  //QAue va a ocurrir cuando se resuelva
  			this.http.post(this.myHttp+"/add/", data) 
  			.map(res=>res.json())
  			.subscribe(
  				data =>{
  						//this.variable = data;  //Puedo hacer comparaciones
  						resolve(data);
  				},
  				err=>{
  					console.log(err);
  				}
  			)
  		}
  	);
  }

   addAprueba(data){
  	return new Promise(
  		resolve=>{  //QAue va a ocurrir cuando se resuelva
  			this.http.put(this.myHttp+"/updateAprueba", data) 
  			.map(res=>res.json())
  			.subscribe(
  				data =>{
  						//this.variable = data;  //Puedo hacer comparaciones
  						resolve(data);
  				},
  				err=>{
  					console.log(err);
  				}
  			)
  		}
  	);
  }

  update(data){
  	return new Promise(
  		resolve=>{  //QAue va a ocurrir cuando se resuelva
  			this.http.put(this.myHttp+"/update", data) 
  			.map(res=>res.json())
  			.subscribe(
  				data =>{
  						//this.variable = data;  //Puedo hacer comparaciones
  						resolve(data);
  				},
  				err=>{
  					console.log(err);
  				}
  			)
  		}
  	);
  }

  delete(id){
  	return new Promise(
  		resolve=>{  //QAue va a ocurrir cuando se resuelva
  			this.http.delete(this.myHttp+"/delete/"+id) 
  			.map(res=>res.json())
  			.subscribe(
  				data =>{
  						//this.variable = data;  //Puedo hacer comparaciones
  						resolve(data);
  				},
  				err=>{
  					console.log(err);
  				}
  			)
  		}
  	);
  }



  
}
